Index: issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateNodesThermal.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateNodesThermal.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateNodesThermal.cpp	(revision 13975)
@@ -16,16 +16,12 @@
 
 	/*Intermediary*/
-	int i;
 	bool continuous_galerkin=true;
-	int    numberofvertices;
-
-	/*DataSets: */
-	Nodes*    nodes = NULL;
 
 	/*Fetch parameters: */
+	int    numberofvertices;
 	iomodel->Constant(&numberofvertices,MeshNumberofverticesEnum);
 
 	/*Recover pointer: */
-	nodes=*pnodes;
+	Nodes* nodes=*pnodes;
 
 	/*Create nodes if they do not exist yet*/
@@ -38,6 +34,5 @@
 	iomodel->FetchData(6,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,MaskVertexongroundediceEnum,MaskVertexonfloatingiceEnum,FlowequationVertexEquationEnum,MaskVertexonwaterEnum);
 
-	for (i=0;i<numberofvertices;i++){
-
+	for(int i=0;i<numberofvertices;i++){
 		if(iomodel->my_vertices[i]){
 			/*Add node to nodes dataset: */
@@ -49,5 +44,5 @@
 	/*Clean fetched data: */
 	iomodel->DeleteData(6,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,MaskVertexongroundediceEnum,MaskVertexonfloatingiceEnum,FlowequationVertexEquationEnum,MaskVertexonwaterEnum);
-	
+
 	/*Assign output pointer: */
 	*pnodes=nodes;
Index: issm/trunk/src/c/modules/NodalValuex/NodalValuex.cpp
===================================================================
--- issm/trunk/src/c/modules/NodalValuex/NodalValuex.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/NodalValuex/NodalValuex.cpp	(revision 13975)
@@ -12,5 +12,5 @@
 void NodalValuex( IssmDouble* pnodalvalue, int natureofdataenum,Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units){
 
-	extern int my_rank;
+	int my_rank;
 	int i;
 	int index;
@@ -21,4 +21,7 @@
 	int cpu_found;
 
+	/*Get my_rank:*/
+	my_rank=IssmComm::GetRank();
+
 	/*retrieve element we are interested in: */
 	parameters->FindParam(&index,IndexEnum);
@@ -27,5 +30,5 @@
 	 *element, figure out  if they hold the vertex, and the data. If so, return it: */
 	for(i=0;i<elements->Size();i++){
-		Element* element=(Element*)elements->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		found=element->NodalValue(&value,index,natureofdataenum,process_units);
 		if (found){
@@ -37,5 +40,5 @@
 	/*Broadcast whether we found the element: */
 	#ifdef _HAVE_MPI_
-	MPI_Allreduce ( &found,&sumfound,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
+	MPI_Allreduce ( &found,&sumfound,1,MPI_INT,MPI_SUM,IssmComm::GetComm());
 	if(!sumfound)_error_("could not find element with vertex with id" << index << " to compute nodal value " << EnumToStringx(natureofdataenum));
 	#endif
@@ -43,6 +46,6 @@
 	/*Broadcast and plug into response: */
 	#ifdef _HAVE_MPI_
-	MPI_Allreduce ( &cpu_found,&cpu_found,1,MPI_INT,MPI_MAX,MPI_COMM_WORLD);
-	MPI_Bcast(&value,1,MPI_DOUBLE,cpu_found,MPI_COMM_WORLD); 
+	MPI_Allreduce ( &cpu_found,&cpu_found,1,MPI_INT,MPI_MAX,IssmComm::GetComm());
+	MPI_Bcast(&value,1,MPI_DOUBLE,cpu_found,IssmComm::GetComm()); 
 	#else
 	value=cpu_found;
Index: issm/trunk/src/c/modules/NodesDofx/NodesDofx.cpp
===================================================================
--- issm/trunk/src/c/modules/NodesDofx/NodesDofx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/NodesDofx/NodesDofx.cpp	(revision 13975)
@@ -14,6 +14,5 @@
 	int noerr=1;
 	int found=0;
-	int i;
-	
+
 	/*Do we have any nodes for this analysis type? :*/
 	if(nodes->NumberOfNodes(configuration_type)){ 
Index: issm/trunk/src/c/modules/Orthx/Orthx.cpp
===================================================================
--- issm/trunk/src/c/modules/Orthx/Orthx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/Orthx/Orthx.cpp	(revision 13975)
@@ -6,10 +6,10 @@
 
 void	Orthx( Vector<IssmDouble>** pnewgradj, Vector<IssmDouble>* gradj, Vector<IssmDouble>* oldgradj){
-	
+
 	/*output: */
 	Vector<IssmDouble>* newgradj=NULL;
 
 	/*intermediary:*/
-	IssmDouble norm_new,norm_old,dot_product;;
+	IssmDouble norm_old,dot_product;;
 
 	/*Initialize output*/
Index: issm/trunk/src/c/modules/OutputResultsx/OutputResultsx.cpp
===================================================================
--- issm/trunk/src/c/modules/OutputResultsx/OutputResultsx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/OutputResultsx/OutputResultsx.cpp	(revision 13975)
@@ -15,8 +15,8 @@
 #include "../../io/io.h"
 #include "../../classes/objects/objects.h"
-		
+
 void OutputResultsx(Elements* elements, Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,Results* results){
 
-	extern int  my_rank;
+	int         my_rank;
 	FILE       *fid                     = NULL;
 	char       *outputfilename          = NULL;
@@ -26,7 +26,10 @@
 	char*       solutiontypestring      = NULL;
 	bool        dakota_analysis         = false;
-	
+
 	/*retrieve parameters: */
 	parameters->FindParam(&dakota_analysis,QmuIsdakotaEnum);
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
 
 	if(dakota_analysis){
@@ -51,5 +54,5 @@
 	/*Now, open file for writing, if not already done: */
 	if(!parameters->Exist(OutputFilePointerEnum)){
-		
+
 		/*We don't have a file pointer. Retrieve the output file name and open it for writing:*/
 		parameters->FindParam(&outputfilename,OutputfilenameEnum);
@@ -69,5 +72,5 @@
 		}
 		xDelete<char>(outputfilename);
-		
+
 		/*Add file pointer in parameters for further calls to OutputResultsx: */
 		parameters->SetParam(fid,OutputFilePointerEnum);
Index: issm/trunk/src/c/modules/OutputRiftsx/OutputRiftsx.cpp
===================================================================
--- issm/trunk/src/c/modules/OutputRiftsx/OutputRiftsx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/OutputRiftsx/OutputRiftsx.cpp	(revision 13975)
@@ -17,5 +17,5 @@
 
 	/*Allocate grad_g: */
-	riftproperties=NewVec(numrifts);
+	riftproperties=NewVec(numrifts,IssmComm::GetComm());
 
 	/*Compute rift properties : */
Index: issm/trunk/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.cpp
===================================================================
--- issm/trunk/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.cpp	(revision 13975)
@@ -23,5 +23,5 @@
 
 	char line [1000];
-	extern int my_rank;
+	int my_rank;
 	int i;
 
@@ -34,4 +34,7 @@
 	char* catstring=NULL;
 	int   stringlength;
+
+	/*Get my_rank:*/
+	my_rank=IssmComm::GetRank();
 
 	if(my_rank==0){
@@ -56,11 +59,11 @@
 		numanalyses=0;
 		while ( fgets(line, sizeof line, fid) ){
-		
+
 			/*skip comments and empty lines: */
 			if ((line[0]=='%') || (line[0]=='\n') || (line[0]==' ') || (line[0]=='\t') || (line[0]=='\r'))continue;
-		
+
 			/*Get rid of end of line: */
 			line[strlen(line)-1]='\0';
-		
+
 			if (line[0]=='+'){ /*this is the analysis line: */
 				analyses[numanalyses]=StringToEnumx(&line[1]);  //skip the '+'
@@ -96,10 +99,10 @@
 	/*Ok, broadcast to other cpus: */
  	#ifdef _HAVE_MPI_
-	MPI_Bcast(&numanalyses,1,MPI_INT,0,MPI_COMM_WORLD);
+	MPI_Bcast(&numanalyses,1,MPI_INT,0,IssmComm::GetComm());
 	if(my_rank!=0){
 		analyses=xNew<IssmPDouble>(numanalyses);
 		strings=xNew<char*>(numanalyses);
 	}
-	MPI_Bcast(analyses,numanalyses,MPI_DOUBLE,0,MPI_COMM_WORLD);
+	MPI_Bcast(analyses,numanalyses,MPI_DOUBLE,0,IssmComm::GetComm());
 	#endif
 	for(i=0;i<numanalyses;i++){
@@ -110,7 +113,7 @@
 		if(my_rank==0)stringlength=(strlen(string)+1)*sizeof(char);
 		#ifdef _HAVE_MPI_
-		MPI_Bcast(&stringlength,1,MPI_INT,0,MPI_COMM_WORLD);
+		MPI_Bcast(&stringlength,1,MPI_INT,0,IssmComm::GetComm());
 		if(my_rank!=0)string=xNew<char>(stringlength);
-		MPI_Bcast(string,stringlength,MPI_CHAR,0,MPI_COMM_WORLD);
+		MPI_Bcast(string,stringlength,MPI_CHAR,0,IssmComm::GetComm());
 		if(my_rank!=0)strings[i]=string;
 		#endif
Index: issm/trunk/src/c/modules/PositiveDegreeDayx/PositiveDegreeDayx.cpp
===================================================================
--- issm/trunk/src/c/modules/PositiveDegreeDayx/PositiveDegreeDayx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/PositiveDegreeDayx/PositiveDegreeDayx.cpp	(revision 13975)
@@ -35,12 +35,12 @@
   IssmDouble PDup, PDCUT = 2.0;    // PDcut: rain/snow cutoff temperature (C)
   IssmDouble tstar; // monthly mean surface temp
-  
+
   IssmDouble* pdds=NULL; 
   IssmDouble* pds=NULL; 
   Element* element = NULL;
-  
+
   pdds=xNew<IssmDouble>(NPDMAX+1); 
   pds=xNew<IssmDouble>(NPDCMAX+1); 
-  
+
   // initialize PDD (creation of a lookup table)
   tstep = 0.1;
@@ -55,5 +55,5 @@
 
   itm = reCast<int,IssmDouble>((2*siglim/DT + 1.5));
-  
+
   if (itm >= NPDMAX){
     _printLine_("increase NPDMAX in massBalance.cpp");
@@ -73,5 +73,5 @@
   }
   pdds[itm+1] = siglim + DT;
-  
+
   //*********compute PD(T) : snow/precip fraction. precipitation falling as snow
   tstepc = 0.1;
@@ -100,7 +100,7 @@
   pds[itm+1] = 0.;
   //     *******END initialize PDD
-  
+
   for(i=0;i<elements->Size();i++){
-    element=(Element*)elements->GetObjectByOffset(i);
+    element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
     element->PositiveDegreeDay(pdds,pds,signorm);
   }
@@ -108,4 +108,4 @@
   xDelete<IssmDouble>(pdds);
   xDelete<IssmDouble>(pds);
-  
+
 }
Index: issm/trunk/src/c/modules/Reduceloadx/Reduceloadx.cpp
===================================================================
--- issm/trunk/src/c/modules/Reduceloadx/Reduceloadx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/Reduceloadx/Reduceloadx.cpp	(revision 13975)
@@ -20,5 +20,5 @@
 	int         global_m,global_n;
 	bool        fromlocalsize = true;
-	int         verbose;
+	bool        oldalloc  = false;
 
 	if(VerboseModule()) _pprintLine_("   Dirichlet lifting applied to load vector");
@@ -32,5 +32,9 @@
 		/*pf = pf - Kfs * y_s;*/
 		Kfs->GetLocalSize(&Kfsm,&Kfsn);
-		Kfsy_s=new Vector<IssmDouble>(Kfsm,fromlocalsize);
+		if(oldalloc)
+		 Kfsy_s=new Vector<IssmDouble>(Kfsm,fromlocalsize);
+		else
+		 Kfsy_s=new Vector<IssmDouble>(Kfsm,global_m);
+
 		if (flag_ys0){
 
@@ -49,5 +53,4 @@
 	}
 
-
 	/*Free ressources and return*/
 	xdelete(&y_s0);
Index: issm/trunk/src/c/modules/Reducevectorgtofx/Reducevectorgtofx.cpp
===================================================================
--- issm/trunk/src/c/modules/Reducevectorgtofx/Reducevectorgtofx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/Reducevectorgtofx/Reducevectorgtofx.cpp	(revision 13975)
@@ -5,5 +5,5 @@
 
 #include "./Reducevectorgtofx.h"
- 
+
 void Reducevectorgtofx(Vector<IssmDouble>** puf, Vector<IssmDouble>* ug, Nodes* nodes,Parameters* parameters){
 
@@ -12,12 +12,16 @@
 
 	/*variables: */
-	int i;
-	int configuration_type;
-	int fsize;
-	IssmDouble* ug_serial=NULL;
+	int         configuration_type;
+	int         fsize;
+	IssmDouble *ug_serial = NULL;
+	bool        oldalloc  = false;
 
 	/*first figure out fsize: */
 	parameters->FindParam(&configuration_type,ConfigurationTypeEnum);
 	fsize=nodes->NumberOfDofs(configuration_type,FsetEnum);
+
+	int    analysis_type;
+	parameters->FindParam(&analysis_type,AnalysisTypeEnum);
+	int flocalsize = nodes->NumberOfDofsLocal(analysis_type,FsetEnum);
 
 	if(fsize==0){
@@ -26,5 +30,8 @@
 	else{
 		/*allocate: */
-		uf=new Vector<IssmDouble>(fsize);
+		if(oldalloc)
+		 uf=new Vector<IssmDouble>(fsize);
+		else
+		 uf=new Vector<IssmDouble>(flocalsize,fsize);
 
 		if(nodes->NumberOfNodes(configuration_type)){ 
@@ -34,5 +41,5 @@
 
 			/*Go through all nodes, and ask them to retrieve values from ug, and plug them into uf: */
-			for(i=0;i<nodes->Size();i++){
+			for(int i=0;i<nodes->Size();i++){
 
 				Node* node=(Node*)nodes->GetObjectByOffset(i);
Index: issm/trunk/src/c/modules/Reducevectorgtosx/Reducevectorgtosx.cpp
===================================================================
--- issm/trunk/src/c/modules/Reducevectorgtosx/Reducevectorgtosx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/Reducevectorgtosx/Reducevectorgtosx.cpp	(revision 13975)
@@ -21,4 +21,10 @@
 	ssize=nodes->NumberOfDofs(configuration_type,SsetEnum);
 
+	int analysis_type;
+	parameters->FindParam(&analysis_type,AnalysisTypeEnum);
+	int slocalsize = nodes->NumberOfDofsLocal(analysis_type,SsetEnum);
+
+	bool oldalloc = false;
+
 	if(ssize==0){
 		ys=NULL;
@@ -26,5 +32,8 @@
 	else{
 		/*allocate: */
-		ys=new Vector<IssmDouble>(ssize);
+		if(oldalloc)
+		 ys=new Vector<IssmDouble>(ssize);
+		else
+		 ys=new Vector<IssmDouble>(slocalsize,ssize);
 
 		if(nodes->NumberOfNodes(configuration_type)){ 
Index: issm/trunk/src/c/modules/ResetConstraintsx/ResetConstraintsx.cpp
===================================================================
--- issm/trunk/src/c/modules/ResetConstraintsx/ResetConstraintsx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ResetConstraintsx/ResetConstraintsx.cpp	(revision 13975)
@@ -12,9 +12,4 @@
 
 void ResetConstraintsx(Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads,Materials* materials,  Parameters* parameters){
-
-	int i;
-
-	extern int num_procs;
-	extern int my_rank;
 
 	/*output: */
Index: issm/trunk/src/c/modules/ResetCoordinateSystemx/ResetCoordinateSystemx.cpp
===================================================================
--- issm/trunk/src/c/modules/ResetCoordinateSystemx/ResetCoordinateSystemx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ResetCoordinateSystemx/ResetCoordinateSystemx.cpp	(revision 13975)
@@ -13,5 +13,5 @@
 
 	for (int i=0;i<elements->Size();i++){
-		element=(Element*)elements->GetObjectByOffset(i);
+		element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->ResetCoordinateSystem();
 	}
Index: issm/trunk/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.cpp
===================================================================
--- issm/trunk/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.cpp	(revision 13975)
@@ -22,5 +22,5 @@
 	/*Compute Misfit: */
 	for (i=0;i<elements->Size();i++){
-		element=(Element*)elements->GetObjectByOffset(i);
+		element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		J+=element->RheologyBbarAbsGradient(process_units,weight_index);
 	}
@@ -28,6 +28,6 @@
 	/*Sum all J from all cpus of the cluster:*/
 	#ifdef _HAVE_MPI_
-	MPI_Reduce (&J,&J_sum,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD );
-	MPI_Bcast(&J_sum,1,MPI_DOUBLE,0,MPI_COMM_WORLD);
+	MPI_Reduce (&J,&J_sum,1,MPI_DOUBLE,MPI_SUM,0,IssmComm::GetComm() );
+	MPI_Bcast(&J_sum,1,MPI_DOUBLE,0,IssmComm::GetComm());
 	J=J_sum;
 	#endif
Index: issm/trunk/src/c/modules/SmbGradientsx/SmbGradientsx.cpp
===================================================================
--- issm/trunk/src/c/modules/SmbGradientsx/SmbGradientsx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/SmbGradientsx/SmbGradientsx.cpp	(revision 13975)
@@ -18,9 +18,9 @@
 
   int    i;
-  
+
   Element* element = NULL;
-  
+
   for(i=0;i<elements->Size();i++){
-    element=(Element*)elements->GetObjectByOffset(i);
+    element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
     element->SmbGradients();
   }
Index: issm/trunk/src/c/modules/Solverx/DofTypesToIndexSet.cpp
===================================================================
--- issm/trunk/src/c/modules/Solverx/DofTypesToIndexSet.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/Solverx/DofTypesToIndexSet.cpp	(revision 13975)
@@ -12,5 +12,5 @@
 #error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
 #endif
-        
+
 void DofTypesToIndexSet(IS* pisv, IS* pisp, Vec df,int typeenum){
 
@@ -62,12 +62,12 @@
 		}
 		VecRestoreArray(df,&df_local);
-		
+
 		/*Create indices sets: */
 		#if _PETSC_MAJOR_ < 3 || (_PETSC_MAJOR_ == 3 && _PETSC_MINOR_ < 2)
-		ISCreateGeneral(PETSC_COMM_WORLD,pressure_num,pressure_indices,&isp);
-		ISCreateGeneral(PETSC_COMM_WORLD,velocity_num,velocity_indices,&isv);
+		ISCreateGeneral(IssmComm::GetComm(),pressure_num,pressure_indices,&isp);
+		ISCreateGeneral(IssmComm::GetComm(),velocity_num,velocity_indices,&isv);
 		#else
-		ISCreateGeneral(PETSC_COMM_WORLD,pressure_num,pressure_indices,PETSC_COPY_VALUES,&isp);
-		ISCreateGeneral(PETSC_COMM_WORLD,velocity_num,velocity_indices,PETSC_COPY_VALUES,&isv);
+		ISCreateGeneral(IssmComm::GetComm(),pressure_num,pressure_indices,PETSC_COPY_VALUES,&isp);
+		ISCreateGeneral(IssmComm::GetComm(),velocity_num,velocity_indices,PETSC_COPY_VALUES,&isv);
 		#endif
 	}
Index: issm/trunk/src/c/modules/Solverx/Solverx.cpp
===================================================================
--- issm/trunk/src/c/modules/Solverx/Solverx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/Solverx/Solverx.cpp	(revision 13975)
@@ -15,7 +15,4 @@
 
 void	Solverx(Vector<IssmDouble>** puf, Matrix<IssmDouble>* Kff, Vector<IssmDouble>* pf, Vector<IssmDouble>* uf0,Vector<IssmDouble>* df, Parameters* parameters){
-
-	/*Intermediary: */
-	int analysis_type;
 
 	/*output: */
Index: issm/trunk/src/c/modules/Solverx/Solverx.h
===================================================================
--- issm/trunk/src/c/modules/Solverx/Solverx.h	(revision 13405)
+++ issm/trunk/src/c/modules/Solverx/Solverx.h	(revision 13975)
@@ -27,5 +27,5 @@
 void SolverxSeq(IssmPDouble *X, IssmPDouble *A, IssmPDouble *B,int n);
 
-#ifdef _HAVE_ADOLC_
+#if defined(_HAVE_ADOLC_) && !defined(_WRAPPERS_)
 void SolverxSeq(IssmDouble *X,IssmDouble *A,IssmDouble *B,int n, Parameters* parameters);
 // call back functions:
@@ -38,3 +38,2 @@
 
 #endif  /* _SOLVERX_H */
-
Index: issm/trunk/src/c/modules/Solverx/SolverxPetsc.cpp
===================================================================
--- issm/trunk/src/c/modules/Solverx/SolverxPetsc.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/Solverx/SolverxPetsc.cpp	(revision 13975)
@@ -20,5 +20,5 @@
 	Vec uf0_vector = NULL;
 	Vec df_vector  = NULL;
-	
+
 	if(uf0) uf0_vector = uf0->vector;
 	if(df)  df_vector  = df->vector;
@@ -36,5 +36,4 @@
 	/*Intermediary: */
 	int        local_m,local_n,global_m,global_n;
-	int        analysis_type;
 
 	/*Solver */
@@ -70,5 +69,5 @@
 	MatGetSize(Kff,&global_m,&global_n); _assert_(global_m==global_m);
 	if(!global_n){
-		*puf=NewVec(0); return;
+		*puf=NewVec(0,IssmComm::GetComm()); return;
 	}
 
@@ -86,5 +85,5 @@
 	}
 	else{
-		MatGetLocalSize(Kff,&local_m,&local_n);uf=NewVec(local_n,fromlocalsize);
+		MatGetLocalSize(Kff,&local_m,&local_n);uf=NewVec(local_n,IssmComm::GetComm(),fromlocalsize);
 	}
 
@@ -102,5 +101,5 @@
 
 	/*Prepare solver*/
-	KSPCreate(MPI_COMM_WORLD,&ksp);
+	KSPCreate(IssmComm::GetComm(),&ksp);
 	KSPSetOperators(ksp,Kff,Kff,DIFFERENT_NONZERO_PATTERN);
 	KSPSetFromOptions(ksp);
@@ -148,5 +147,5 @@
 	if(VerboseSolver())KSPView(ksp,PETSC_VIEWER_STDOUT_WORLD);
 	KSPSolve(ksp,pf,uf);
-	
+
 	/*Check convergence*/
 	KSPGetIterationNumber(ksp,&iteration_number);
@@ -155,5 +154,5 @@
 	/*Free resources:*/
 	KSPFree(&ksp);
-		
+
 	/*Assign output pointers:*/
 	*puf=uf;
Index: issm/trunk/src/c/modules/Solverx/SolverxSeq.cpp
===================================================================
--- issm/trunk/src/c/modules/Solverx/SolverxSeq.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/Solverx/SolverxSeq.cpp	(revision 13975)
@@ -12,4 +12,5 @@
 #include "./Solverx.h"
 #include "../../shared/shared.h"
+#include "../../classes/classes.h"
 #include "../../include/include.h"
 #include "../../io/io.h"
@@ -19,13 +20,9 @@
 #endif
 
-#ifdef _HAVE_ADOLC_
-#include "../../shared/Numerics/adolc_edf.h"
-#endif
-
 void SolverxSeq(SeqVec<IssmDouble>** puf,SeqMat<IssmDouble>* Kff, SeqVec<IssmDouble>* pf, Parameters* parameters){/*{{{*/
 
 #ifdef _HAVE_GSL_
 	/*Intermediary: */
-	int M,N,N2,s;
+	int M,N,N2;
 	SeqVec<IssmDouble> *uf = NULL;
 
@@ -35,6 +32,8 @@
 	if(N!=N2)_error_("Right hand side vector of size " << N2 << ", when matrix is of size " << M << "-" << N << " !");
 	if(M!=N)_error_("Stiffness matrix should be square!");
+#ifdef _HAVE_ADOLC_
+	ensureContiguousLocations(N);
+#endif
 	IssmDouble *x  = xNew<IssmDouble>(N);
-
 #ifdef _HAVE_ADOLC_
 	SolverxSeq(x,Kff->matrix,pf->vector,N,parameters);
@@ -69,96 +68,139 @@
 #ifdef _HAVE_ADOLC_
 int EDF_for_solverx(int n, IssmPDouble *x, int m, IssmPDouble *y){ /*{{{*/
-    SolverxSeq(y,x, x+m*m, m); // x is where the matrix starts, x+m*m is where the right-hand side starts
-    return 0;
+	SolverxSeq(y,x, x+m*m, m); // x is where the matrix starts, x+m*m is where the right-hand side starts
+	return 0;
 } /*}}}*/
 int EDF_fos_forward_for_solverx(int n, IssmPDouble *inVal, IssmPDouble *inDeriv, int m, IssmPDouble *outVal, IssmPDouble *outDeriv) { /*{{{*/
 #ifdef _HAVE_GSL_
-  // the matrix will be modified by LU decomposition. Use gsl_A copy
-  double* Acopy = xNew<double>(m*m);
-  xMemCpy(Acopy,inVal,m*m);
-  /*Initialize gsl matrices and vectors: */
-  gsl_matrix_view gsl_A = gsl_matrix_view_array (Acopy,m,m);
-  gsl_vector_view gsl_b = gsl_vector_view_array (inVal+m*m,m); // the right hand side starts at address inVal+m*m
-  gsl_permutation *perm_p = gsl_permutation_alloc (m);
-  int  signPerm;
-  // factorize
-  gsl_linalg_LU_decomp (&gsl_A.matrix, perm_p, &signPerm);
-  gsl_vector *gsl_x_p = gsl_vector_alloc (m);
-  // solve for the value
-  gsl_linalg_LU_solve (&gsl_A.matrix, perm_p, &gsl_b.vector, gsl_x_p);
-  /*Copy result*/
-  xMemCpy(outVal,gsl_vector_ptr(gsl_x_p,0),m);
-  gsl_vector_free(gsl_x_p);
-  // solve for the derivatives acc. to A * dx = r  with r=db - dA * x
-  // compute the RHS
-  double* r=xNew<double>(m);
-  for (int i=0; i<m; i++) {
-    r[i]=inDeriv[m*m+i]; // this is db[i]
-    for (int j=0;j<m; j++) {
-      r[i]-=inDeriv[i*m+j]*outVal[j]; // this is dA[i][j]*x[j]
-    }
-  }
-  gsl_vector_view gsl_r=gsl_vector_view_array(r,m);
-  gsl_vector *gsl_dx_p = gsl_vector_alloc(m);
-  gsl_linalg_LU_solve (&gsl_A.matrix, perm_p, &gsl_r.vector, gsl_dx_p);
-  xMemCpy(outDeriv,gsl_vector_ptr(gsl_dx_p,0),m);
-  gsl_vector_free(gsl_dx_p);
-  xDelete(r);
-  gsl_permutation_free(perm_p);
-  xDelete(Acopy);
-  #endif
-  return 0;
+	//  for (int i=0; i<m*m; ++i) std::cout << "EDF_fos_forward_for_solverx A["<< i << "]=" << inVal[i] << std::endl;
+	//  for (int i=0; i<m; ++i) std::cout << "EDF_fos_forward_for_solverx b["<< i << "]=" << inVal[i+m*m] << std::endl;
+	// the matrix will be modified by LU decomposition. Use gsl_A copy
+	double* Acopy = xNew<double>(m*m);
+	xMemCpy(Acopy,inVal,m*m);
+	/*Initialize gsl matrices and vectors: */
+	gsl_matrix_view gsl_A = gsl_matrix_view_array (Acopy,m,m);
+	gsl_vector_view gsl_b = gsl_vector_view_array (inVal+m*m,m); // the right hand side starts at address inVal+m*m
+	gsl_permutation *perm_p = gsl_permutation_alloc (m);
+	int  signPerm;
+	// factorize
+	gsl_linalg_LU_decomp (&gsl_A.matrix, perm_p, &signPerm);
+	gsl_vector *gsl_x_p = gsl_vector_alloc (m);
+	// solve for the value
+	gsl_linalg_LU_solve (&gsl_A.matrix, perm_p, &gsl_b.vector, gsl_x_p);
+	/*Copy result*/
+	xMemCpy(outVal,gsl_vector_ptr(gsl_x_p,0),m);
+	gsl_vector_free(gsl_x_p);
+	//  for (int i=0; i<m; ++i) std::cout << "EDF_fos_forward_for_solverx x["<< i << "]=" << outVal[i] << std::endl;
+	// solve for the derivatives acc. to A * dx = r  with r=db - dA * x
+	// compute the RHS
+	double* r=xNew<double>(m);
+	for (int i=0; i<m; i++) {
+		r[i]=inDeriv[m*m+i]; // this is db[i]
+		for (int j=0;j<m; j++) {
+			r[i]-=inDeriv[i*m+j]*outVal[j]; // this is dA[i][j]*x[j]
+		}
+	}
+	gsl_vector_view gsl_r=gsl_vector_view_array(r,m);
+	gsl_vector *gsl_dx_p = gsl_vector_alloc(m);
+	gsl_linalg_LU_solve (&gsl_A.matrix, perm_p, &gsl_r.vector, gsl_dx_p);
+	xMemCpy(outDeriv,gsl_vector_ptr(gsl_dx_p,0),m);
+	gsl_vector_free(gsl_dx_p);
+	xDelete(r);
+	gsl_permutation_free(perm_p);
+	xDelete(Acopy);
+#endif
+	return 0;
 } /*}}}*/
 int EDF_fov_forward_for_solverx(int n, IssmPDouble *inVal, int directionCount, IssmPDouble **inDeriv, int m, IssmPDouble *outVal, IssmPDouble **outDeriv) { /*{{{*/
 #ifdef _HAVE_GSL_
-  // the matrix will be modified by LU decomposition. Use gsl_A copy
-  double* Acopy = xNew<double>(m*m);
-  xMemCpy(Acopy,inVal,m*m);
-  /*Initialize gsl matrices and vectors: */
-  gsl_matrix_view gsl_A = gsl_matrix_view_array (Acopy,m,m);
-  gsl_vector_view gsl_b = gsl_vector_view_array (inVal+m*m,m); // the right hand side starts at address inVal+m*m
-  gsl_permutation *perm_p = gsl_permutation_alloc (m);
-  int  signPerm;
-  // factorize
-  gsl_linalg_LU_decomp (&gsl_A.matrix, perm_p, &signPerm);
-  gsl_vector *gsl_x_p = gsl_vector_alloc (m);
-  // solve for the value
-  gsl_linalg_LU_solve (&gsl_A.matrix, perm_p, &gsl_b.vector, gsl_x_p);
-  /*Copy result*/
-  xMemCpy(outVal,gsl_vector_ptr(gsl_x_p,0),m);
-  gsl_vector_free(gsl_x_p);
-  // solve for the derivatives acc. to A * dx = r  with r=db - dA * x
-  double* r=xNew<double>(m);
-  gsl_vector *gsl_dx_p = gsl_vector_alloc(m);
-  for (int dir=0;dir<directionCount;++dir) {
-    // compute the RHS
-    for (int i=0; i<m; i++) {
-      r[i]=inDeriv[m*m+i][dir]; // this is db[i]
-      for (int j=0;j<m; j++) {
-        r[i]-=inDeriv[i*m+j][dir]*outVal[j]; // this is dA[i][j]*x[j]
-      }
-    }
-    gsl_vector_view gsl_r=gsl_vector_view_array(r,m);
-    gsl_linalg_LU_solve (&gsl_A.matrix, perm_p, &gsl_r.vector, gsl_dx_p);
-    // reuse r
-    xMemCpy(r,gsl_vector_ptr(gsl_dx_p,0),m);
-    for (int i=0; i<m; i++) {
-      outDeriv[i][dir]=r[i];
-    }
-  }
-  gsl_vector_free(gsl_dx_p);
-  xDelete(r);
-  gsl_permutation_free(perm_p);
-  xDelete(Acopy);
-  #endif
-  return 0;
-}
-/*}}}*/
-int EDF_fos_reverse_for_solverx(int m, double *dp_U, int n, double *dp_Z) { /*{{{*/
-  return 0;
+	// the matrix will be modified by LU decomposition. Use gsl_A copy
+	double* Acopy = xNew<double>(m*m);
+	xMemCpy(Acopy,inVal,m*m);
+	/*Initialize gsl matrices and vectors: */
+	gsl_matrix_view gsl_A = gsl_matrix_view_array (Acopy,m,m);
+	gsl_vector_view gsl_b = gsl_vector_view_array (inVal+m*m,m); // the right hand side starts at address inVal+m*m
+	gsl_permutation *perm_p = gsl_permutation_alloc (m);
+	int  signPerm;
+	// factorize
+	gsl_linalg_LU_decomp (&gsl_A.matrix, perm_p, &signPerm);
+	gsl_vector *gsl_x_p = gsl_vector_alloc (m);
+	// solve for the value
+	gsl_linalg_LU_solve (&gsl_A.matrix, perm_p, &gsl_b.vector, gsl_x_p);
+	/*Copy result*/
+	xMemCpy(outVal,gsl_vector_ptr(gsl_x_p,0),m);
+	gsl_vector_free(gsl_x_p);
+	// solve for the derivatives acc. to A * dx = r  with r=db - dA * x
+	double* r=xNew<double>(m);
+	gsl_vector *gsl_dx_p = gsl_vector_alloc(m);
+	for (int dir=0;dir<directionCount;++dir) {
+		// compute the RHS
+		for (int i=0; i<m; i++) {
+			r[i]=inDeriv[m*m+i][dir]; // this is db[i]
+			for (int j=0;j<m; j++) {
+				r[i]-=inDeriv[i*m+j][dir]*outVal[j]; // this is dA[i][j]*x[j]
+			}
+		}
+		gsl_vector_view gsl_r=gsl_vector_view_array(r,m);
+		gsl_linalg_LU_solve (&gsl_A.matrix, perm_p, &gsl_r.vector, gsl_dx_p);
+		// reuse r
+		xMemCpy(r,gsl_vector_ptr(gsl_dx_p,0),m);
+		for (int i=0; i<m; i++) {
+			outDeriv[i][dir]=r[i];
+		}
+	}
+	gsl_vector_free(gsl_dx_p);
+	xDelete(r);
+	gsl_permutation_free(perm_p);
+	xDelete(Acopy);
+#endif
+	return 0;
+}
+/*}}}*/
+int EDF_fos_reverse_for_solverx(int m, double *dp_U, int n, double *dp_Z, double* dp_x, double* dp_y) { /*{{{*/
+	// copy to transpose the matrix
+	double* transposed=xNew<double>(m*m);
+	for (int i=0; i<m; ++i) for (int j=0; j<m; ++j) transposed[j*m+i]=dp_x[i*m+j];
+	gsl_matrix_view aTransposed = gsl_matrix_view_array (transposed,m,m);
+	// the adjoint of the solution is our right-hand side
+	gsl_vector_view x_bar=gsl_vector_view_array(dp_U,m);
+	// the last m elements of dp_Z representing the adjoint of the right-hand side we want to compute:
+	gsl_vector_view b_bar=gsl_vector_view_array(dp_Z+m*m,m);
+	gsl_permutation *perm_p = gsl_permutation_alloc (m);
+	int permSign;
+	gsl_linalg_LU_decomp (&aTransposed.matrix, perm_p, &permSign);
+	gsl_linalg_LU_solve (&aTransposed.matrix, perm_p, &x_bar.vector, &b_bar.vector);
+	// now do the adjoint of the matrix
+	for (int i=0; i<m; ++i) for (int j=0; j<m; ++j) dp_Z[i*m+j]-=dp_Z[m*m+i]*dp_y[j];
+	gsl_permutation_free(perm_p);
+	xDelete(transposed);
+	return 0;
+}
+/*}}}*/
+int EDF_fov_reverse_for_solverx(int m, int p, double **dpp_U, int n, double **dpp_Z, double* dp_x, double* dp_y) { /*{{{*/
+	// copy to transpose the matrix
+	double* transposed=xNew<double>(m*m);
+	for (int i=0; i<m; ++i) for (int j=0; j<m; ++j) transposed[j*m+i]=dp_x[i*m+j];
+	gsl_matrix_view aTransposed = gsl_matrix_view_array (transposed,m,m);
+	gsl_permutation *perm_p = gsl_permutation_alloc (m);
+	int permSign;
+	gsl_linalg_LU_decomp (&aTransposed.matrix, perm_p, &permSign);
+	for (int weightsRowIndex=0;weightsRowIndex<p;++weightsRowIndex) {
+		// the adjoint of the solution is our right-hand side
+		gsl_vector_view x_bar=gsl_vector_view_array(dpp_U[weightsRowIndex],m);
+		// the last m elements of dp_Z representing the adjoint of the right-hand side we want to compute:
+		gsl_vector_view b_bar=gsl_vector_view_array(dpp_Z[weightsRowIndex]+m*m,m);
+		gsl_linalg_LU_solve (&aTransposed.matrix, perm_p, &x_bar.vector, &b_bar.vector);
+		// now do the adjoint of the matrix
+		for (int i=0; i<m; ++i) for (int j=0; j<m; ++j) dpp_Z[weightsRowIndex][i*m+j]-=dpp_Z[weightsRowIndex][m*m+i]*dp_y[j];
+	}
+	gsl_permutation_free(perm_p);
+	xDelete(transposed);
+	return 0;
 }
 /*}}}*/
 void SolverxSeq(IssmDouble *X,IssmDouble *A,IssmDouble *B,int n, Parameters* parameters){/*{{{*/
 	// pack inputs to conform to the EDF-prescribed interface
+        // ensure a contiguous block of locations:
+        ensureContiguousLocations(n*(n+1));
         IssmDouble*  adoubleEDFin=xNew<IssmDouble>(n*(n+1));  // packed inputs, i.e. matrix and right hand side
         for(int i=0; i<n*n;i++)adoubleEDFin[i]    =A[i];      // pack matrix
@@ -170,4 +212,5 @@
 	             n*(n+1), pdoubleEDFin, adoubleEDFin,
 	             n, pdoubleEDFout,X);
+	// for(int i=0; i<n;  i++) {ADOLC_DUMP_MACRO(X[i]);}
 	xDelete(adoubleEDFin);
 	xDelete(pdoubleEDFin);
@@ -181,7 +224,8 @@
 	int              s;
 	gsl_matrix_view  a;
-	gsl_vector_view  b;
-	gsl_vector      *x = NULL;
+	gsl_vector_view  b,x;
 	gsl_permutation *p = NULL;
+//	for (int i=0; i<n*n; ++i) std::cout << "SolverxSeq A["<< i << "]=" << A[i] << std::endl;
+//	for (int i=0; i<n; ++i) std::cout << "SolverxSeq b["<< i << "]=" << B[i] << std::endl;
 	/*A will be modified by LU decomposition. Use copy*/
 	double* Acopy = xNew<double>(n*n);
@@ -191,22 +235,15 @@
 	a = gsl_matrix_view_array (Acopy,n,n);
 	b = gsl_vector_view_array (B,n);
-	x = gsl_vector_alloc (n);
+	x = gsl_vector_view_array (X,n);
 
 	/*Run LU and solve: */
 	p = gsl_permutation_alloc (n);
 	gsl_linalg_LU_decomp (&a.matrix, p, &s);
-	gsl_linalg_LU_solve (&a.matrix, p, &b.vector, x);
-
-	//printf ("x = \n");
-	//gsl_vector_fprintf (stdout, x, "%g");
-
-	/*Copy result*/
-	xMemCpy(X,gsl_vector_ptr(x,0),n);
+	gsl_linalg_LU_solve (&a.matrix, p, &b.vector, &x.vector);
 
 	/*Clean up and assign output pointer*/
 	xDelete(Acopy);
 	gsl_permutation_free(p);
-	gsl_vector_free(x);
-#endif
-}
-/*}}}*/
+#endif
+}
+/*}}}*/
